/* группировка, распределение
	обработка полужирности, убирается отбивка между телефоном и web-адресом
	проверка цветов.если нет - добавляються,
	вставляются сниппеты, XML-фильтр
*/
#target indesign
#include "/Applications/Adobe InDesign CS3/Scripts/Xml Rules/glue code.jsx"

if (app.documents.length != 0){
	var myDocument = app.activeDocument;
	var myImagesFolder = new Folder ("~/Desktop/images");
	if (myImagesFolder.exists == false) {
		alert("Папка \"" + myImagesFolder + "\" не существует!");
		exit();
	} 
	myPreflight(); 
	myDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.MILLIMETERS;
	myDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.MILLIMETERS;	
	myDocument.viewPreferences.rulerOrigin = RulerOrigin.PAGE_ORIGIN;
	myDocument.zeroPoint = [0, 0];
	var myBounds = [-100, 0];
	var myGroups = new Array;
	var myColorCounter = 0;
	var myColors = new Array;
	var myColorsValues  =	[
										[100, 0, 0, 0],
										[80, 0, 100, 0],
										[0, 0, 100, 0],								
										[100, 60, 0, 0],
										[0, 100, 100, 0],
										[60, 100, 0, 0],
										[0, 44, 96, 0]
										]
	CheckSwatches();
	
if (myDocument.textFrames.item("Сlassified") != null) {
		var myTextFrame = myDocument.textFrames.item("Сlassified");
		LoadXML(myTextFrame);
	}                   
	else if (myDocument.selection.length == 1) {
		if (myDocument.selection[0].constructor.name == "TextFrame") {
			var myTextFrame = myDocument.selection[0];
			LoadXML(myTextFrame);
		}
	}
	else {       
		alert("Не отмечен текстовый блок для вставки XML файла");   
		exit();
	}
}
else{ 
	alert("Не открыт ни один документ!");
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
function ProcessTraveling(){
	this.name = "ProcessTraveling";
	this.xpath = "/Root/traveling";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Путешествия\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessWindows_doors(){
	this.name = "ProcessWindows_doors";
	this.xpath = "/Root/windows_doors";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Окна и двери\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessService(){
	this.name = "ProcessService";
	this.xpath = "/Root/service";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Услуги\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessVacancies(){ 
	this.name = "ProcessVacancies";
	this.xpath = "/Root/vacancies";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Вакансии\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessSale(){
	this.name = "ProcessSale";
	this.xpath = "/Root/sale";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Продам\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
} 
function ProcessLease(){
	this.name = "ProcessLease";
	this.xpath = "/Root/lease";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Аренда\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessMedicine(){
	this.name = "ProcessMedicine";
	this.xpath = "/Root/medicine";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Медицина\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessOther(){
	this.name = "ProcessOther";
	this.xpath = "/Root/other";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Разное\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessRealty(){
	this.name = "ProcessRealty"; 
	this.xpath = "/Root/realty";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Недвижимость\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessPurchase(){
	this.name = "ProcessPurchase";
	this.xpath = "/Root/purchase";
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Куплю\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
function ProcessTeaching(){
	this.name = "ProcessTeaching";
	this.xpath = "/Root/teaching";
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			var myHeader = insertTextAsContent("Обучение\r", XMLElementPosition.beforeElement);
			myHeader.applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds rubrika 03"), true);
			myHeader.paragraphs[0].ruleAboveColor = myColors[myColorCounter];
			ResetSwatches();
		}
	return true;
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
function ProcessText(){
	this.name = "ProcessText";
	this.xpath = "/Root/*/ad/text";	
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			if (contents != "") {
				applyParagraphStyle(myDocument.paragraphStyles.item("_Сlassified tekst"), true);
				insertTextAsContent("\r", XMLElementPosition.afterElement);
				if (IsBold(myElement) == true){
					applyCharacterStyle(myDocument.characterStyles.item("Bold"), true);
				}
			}
		}
	return true;
	}
}
function ProcessPhone(){ 
	this.name = "ProcessPhone";
	this.xpath = "/Root/*/ad/phone";		 
	this.apply = function(myElement, myRuleProcessor){ 
		with(myElement){
			if (contents != "") {
				applyParagraphStyle(myDocument.paragraphStyles.item("_Сlassified tel"), true);
				insertTextAsContent("\r", XMLElementPosition.afterElement);
				if (IsBold(myElement) == true){
					applyCharacterStyle(myDocument.characterStyles.item("Bold"), true);
				}
			}
		}
	return true;          
	}
}
function ProcessWeb(){ 
	this.name = "ProcessWeb";                
	this.xpath = "/Root/*/ad/web_address";		  
	this.apply = function(myElement, myRuleProcessor){
		with(myElement){
			if (contents != "") {
				applyParagraphStyle(myDocument.paragraphStyles.item("_Classifieds www"), true);
				insertTextAsContent("\r", XMLElementPosition.afterElement);
				if (IsBold(myElement) == true){
					applyCharacterStyle(myDocument.characterStyles.item("Bold"), true);
				}
			}
		}
	return true;           
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
function ProcessAd(){ 
	this.name = "ProcessAd";
	this.xpath = "/Root/*/ad";		  
	this.apply = function(myElement, myRuleProcessor){
 		with(myElement){
			if (xmlAttributes.item("file") != null) {
				var myPicFile = new File (myImagesFolder + "/" + xmlAttributes.item("file").value);
				if (myPicFile.exists == true) {
					var myPic = app.activeWindow.activePage.place(myPicFile, myBounds, undefined, false, false);
					if (myPic[0].constructor.name == "Story") {
						var myPlacedItem = myPic[0].texts[0].parentTextFrames[0];
						var myPicBounds = myPlacedItem.geometricBounds;
					}
					else {
						var myPlacedItem = myPic[0].parent;
						var myPicBounds = myPic[0].parent.geometricBounds;
					}
					var myCommentBounds = [ 
															myPicBounds[2], 
															myPicBounds[1], 
															myPicBounds[2]+10, 
															myPicBounds[3] 
															]
				}    
			} 
			if (xmlComments.length > 0) {
				var mySection = FindSection(myElement);
				var myComment = xmlComments.everyItem().value;
				var myText = mySection + myComment.join("\n");
				if (myCommentBounds == null) {
					myCommentBounds = [0,-100, 15, -30]; 
				}
				var myCommentFrame = app.activeWindow.activeSpread.textFrames.add({contents:myText, geometricBounds:myCommentBounds});
				myCommentFrame.fillColor = myDocument.swatches.item("C=0 M=0 Y=100 K=0");
				myCommentFrame.paragraphs.everyItem().applyCharacterStyle(myDocument.characterStyles.item("[None]"));
				myCommentFrame.paragraphs.everyItem().applyParagraphStyle(myDocument.paragraphStyles.item("_Сlassified tekst"), true);
				myCommentFrame.nonprinting = true;
				myCommentFrame.textFramePreferences.insetSpacing  = 1;
				myCommentFrame.fit(FitOptions.FRAME_TO_CONTENT);
			}
			if (myPic != null && myCommentFrame != null) {
				var myGroup = app.activeWindow.activeSpread.groups.add([myPlacedItem, myCommentFrame]);
				myGroups.push(myGroup);
			}
			else if (myPic == null && myCommentFrame != null) {
				myGroups.push(myCommentFrame);
			}
		}
	return true; 
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
function myPreflight(){
	if (myDocument.paragraphStyles.item("_Classifieds rubrika 03") == null) {
		alert("Нет стиля абзаца \"_Classifieds rubrika 03\" !");
		exit();  
	}
                	if (myDocument.paragraphStyles.item("_Сlassified tel") == null) {
		alert("Нет стиля абзаца \"_Classified tel\" !");
		exit();
	}
	if (myDocument.paragraphStyles.item("_Classifieds www") == null) {
		alert("Нет стиля абзаца \"_Classifieds www\" !");
		exit();
	}
	if (myDocument.characterStyles.item("Bold") == null) {
		myDocument.characterStyles.add({name:"Bold", fontStyle:"Bold"});
	}
	if (myDocument.xmlElements[0].xmlElements.length > 0) {
		alert("XML файл уже был вставлен, чтобы вставить его заново, удалите елемент \"Root\"");
		exit();	
	}
}
function SetXMLPrefs() {
	var myXMLImportPreferences = myDocument.xmlImportPreferences;
	myXMLImportPreferences.allowTransform = false;
	myXMLImportPreferences.createLinkToXML = false;
	myXMLImportPreferences.ignoreUnmatchedIncoming = false;
	myXMLImportPreferences.ignoreWhitespace = true;
	myXMLImportPreferences.importCALSTables = false;
	myXMLImportPreferences.importStyle = XMLImportStyles.mergeImport;
	myXMLImportPreferences.importTextIntoTables = false;
	myXMLImportPreferences.importToSelected = false;
	myXMLImportPreferences.removeUnmatchedExisting = false;
	myXMLImportPreferences.repeatTextElements = false;
}
function LoadXML(myTextFrame) {
	var myFile = File.openDialog("Выберите файл в формате XML", fileFilter);
	if( myFile != null ) {
		if( myFile.exists == true  ) {
			SetXMLPrefs();
			myDocument.importXML(myFile); 
			myDocument.xmlElements.item(0).placeXML(myTextFrame);
		var myRuleSet = new Array (new ProcessTraveling,
													new ProcessTeaching,
													new ProcessWindows_doors,
													new ProcessService,         
													new ProcessVacancies,
													new ProcessSale,
													new ProcessLease,
													new ProcessMedicine,  
													new ProcessOther,
													new ProcessPurchase,   
													new ProcessRealty,
													new ProcessText, 
													new ProcessPhone,
													new ProcessWeb,
													new ProcessAd);
			with(myDocument){                     
				var elements = xmlElements; 
				__processRuleSet(elements.item(0), myRuleSet);
			} 
		AlignGroups();
		ReajustParagraphs(myTextFrame);
		// myDocument.xmlElements.item(0).untag();
		alert("Готово!");
		}
		else {     
			exit();
		}
	}
}
function AlignGroups() {
	myDocument.distribute(myGroups, DistributeOptions.VERTICAL_SPACE, AlignDistributeBounds.SPREAD_BOUNDS, false);
	for (var j = myGroups.length - 1; j >= 0; j--) {
		if (myGroups[j].constructor.name == "Group") {
			myGroups[j].ungroup();
		}
	}
}
function FindSection(myElement) {
	if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("realty")) {
		return "Недвижимость\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("traveling")) {
		return "Путешествия\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("teaching")) {
		return "Обучение\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("windows_doors")) {
		return "Окна и двери\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("service")) {
		return "Услуги\n";
	} 
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("vacancies")) {
		return "Вакансии\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("sale")) {
		return "Продам\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("lease")) {
		return "Аренда\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("other")) {
		return "Разное\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("medicine")) {
		return "Медицина\n";
	}
	else if (myElement.parent == myDocument.xmlElements.item(0).xmlElements.item("purchase")) {
		return "Куплю\n";
	}
	else {
		return "Раздел не определен\n";
	}
}
function IsBold(myElement) {
	var myBold = false;
	if (myElement.parent.xmlAttributes.item('type') != null) {
		if(myElement.parent.xmlAttributes.item('type').value == 'bold') {
			myBold = true;
		}
	}
	return myBold;
}
function ReajustParagraphs(myTextFrame) {
var myParagraphs = myDocument.textFrames.item("Сlassified").paragraphs;
var myLastPar = myParagraphs.lastItem();
	if (myLastPar.appliedParagraphStyle.name == "_Сlassified tel"){
		myParagraphs.previousItem(myLastPar).characters[-1].remove();
	}
	for (i = 0; i < myParagraphs.length; i++)  {
		try {
			var myNextPar = myParagraphs.nextItem(myParagraphs[i]);
			if (myParagraphs[i].appliedParagraphStyle.name == "_Сlassified tel" && myNextPar.appliedParagraphStyle.name == "_Classifieds www"){
				myParagraphs[i].spaceAfter = 0;
			}
		}
		catch (myError){}              
	}
}
// Проверка цветов
function CheckSwatches() {
	for (i=0; i<myColorsValues.length; i++)  {
		var myCurArray = myColorsValues[i];
		var myColorName = "C=" + myCurArray[0] + " M=" + myCurArray[1] +  " Y=" + myCurArray[2] + " K=" + myCurArray[3];
		if (myDocument.swatches.item(myColorName) == null){
			var myCurColor = myDocument.colors.add({colorValue:myCurArray, name:myColorName});
			myColors.push(myCurColor);
		}
		else {
			myColors.push(myDocument.colors.item(myColorName));
		}
	}
}
function ResetSwatches() {
	if (myColorCounter < myColorsValues.length-1) {
		myColorCounter++;
	}
	else {
		myColorCounter = 0;
	}
}
function fileFilter(f) {
	var myExtention = ".xml";
	var lCaseName = f.name;
	lCaseName.toLowerCase();
	if (lCaseName.indexOf(myExtention) == f.name.length - myExtention.length)
		return true;
	else if (f instanceof Folder)
		return true;
	else
		return false;
}
